<?php
/*
 *********************************************************************************
 * class StringTokenizer
 *********************************************************************************
 */

/*
 * Create StringTokenizer
 */

class StringTokenizer	{

	/**
	 * Constructeur
	 */
	function StringTokenizer($str) {
		$this->setString($str);
		$this->lastSep= "";
	}

	/**
	 * fonction
	 */
	function restart() {
		$this->curPos= 0;
		$this->active= 1;
		$this->lastPos= 0;
		$this->lastString= '';
	}

	/**
	 * fonction
	 */
	function setString($str) {
		/// change html conventions
		$str = preg_replace('/\&quot;/','"',$str);

		// some modifications...
		$str = preg_replace('/0-0-0/',"O-O-O",$str);
		$str = preg_replace('/0-0/',"O-O",$str);

		// add space before and after ()[]{}, ...
		$str = preg_replace('/([\(\)\{\}\[\]])/'," $1 ",$str);


		// Replace all tabs, linefeeds, and returns with spaces.
		$str = preg_replace('/[\t\n\r]/'," ",$str);

		// remove space before period
		$str = preg_replace('/ \./',".",$str);
		// remove move number, ...
		// str = preg_replace('[0-9][0-9]*\.\.\.'," ",$str);
		// str = preg_replace('[0-9][0-9]*\.'," ",$str);
		// str = preg_replace('\.\.\.'," ",$str);

		$this->pgnString= $this->htmlFilter($str);
		$this->restart();
	}

	/**
	 * fonction
	 */
	function unread() {
		$this->curPos= $this->lastPos;
	}

	/**
	 * fonction
	 */
	function hasMoreGame() {
		$curPos= $this->curPos;

		// skip spaces
		while ($curPos < strlen($this->pgnString) && substr($this->pgnString,$curPos,1)==' ') {
			$curPos++;
		}

		// end of string ?
		if ($curPos >= strlen($this->pgnString)) return(false);
		return(true);
	}

	/**
	 * fonction
	 */
	function nextToken() {
		$this->lastPos= $this->curPos;

		// skip spaces
		while ($this->curPos < strlen($this->pgnString) && substr($this->pgnString,$this->curPos,1)==' ') {
			$this->curPos++;
		}
		$startPos= $this->curPos;

		// end of string
		if ($this->curPos >= strlen($this->pgnString)) return("");

		switch(substr($this->pgnString,$this->curPos,1)) {

			case '"': // delimited string : "..."
				$this->curPos++;
				$startPos++;
				$this->lastSep= '"';
				$sep= '"';
				break;

			case '{': // comment
				$this->curPos++;
				$startPos++;
				$this->lastSep= '{';
				$sep= '}';
				break;

			default: // space
				$this->lastSep= ' ';
				$sep= ' ';
				break;

		}


		// search next spaces or separator
		while ($this->curPos < strlen($this->pgnString) && substr($this->pgnString,$this->curPos,1)!=$sep) {
			$this->curPos++;
		}
		$endPos= $this->curPos;
		if ($sep!=' ') {
			// go to next char (space)
			$this->curPos++;
		}

		// return string
		$this->lastStr= substr($this->pgnString,$startPos,$endPos - $startPos);

		return $this->lastStr;

	}

	/**
	 * fonction
	 */
	function htmlFilter($str) {
		$i= 0;
		$result= '';
		while ( $i<strlen($str) ) {
			$car= substr($str,$i,1);
			switch($car) {
				case '': $car= '&eacute;'; break;
				case '': $car= '&egrave;'; break;
				case '': $car= '&euml;'; break;
				case '': $car= '&ecirc;'; break;
				case '': $car= '&Eacute;'; break;
				case '': $car= '&Egrave;'; break;
				case '': $car= '&Euml;'; break;
				case '': $car= '&Ecirc;'; break;

				case '': $car= '&agrave;'; break;
				case '': $car= '&auml;'; break;
				case '': $car= '&acirc;'; break;
				case '': $car= '&Agrave;'; break;
				case '': $car= '&Auml;'; break;
				case '': $car= '&Acirc;'; break;

				case '': $car= '&iuml;'; break;
				case '': $car= '&icirc;'; break;
				case '': $car= '&Iuml;'; break;
				case '': $car= '&Icirc;'; break;

				case '': $car= '&ouml;'; break;
				case '': $car= '&ocirc;'; break;
				case '': $car= '&Ouml;'; break;
				case '': $car= '&Ocirc;'; break;

				case '': $car= '&ugrave;'; break;
				case '': $car= '&uuml;'; break;
				case '': $car= '&ucirc;'; break;
				case '': $car= '&Ugrave;'; break;
				case '': $car= '&Uuml;'; break;
				case '': $car= '&Ucirc;'; break;

				default:
					$ascii= ord($car);
					if ($ascii > 127) {
						$car= '('.$ascii.')';
					}
					break;
			}
			$result= $result . $car;
			$i++;
		}
		return $result;
	}

	/**
	 * fonction
	 */
	function dump() {
		$str= $this->pgnString;
		$i= 0;
		while ( $i<strlen($str) ) {
			$car= substr($str,$i,1);
			switch($car) {
				case '<': $car= '&lt;'; break;
				case '>': $car= '&gt;'; break;
				case '&': $car= '&amp;'; break;
				default:
					$ascii= ord($car);
					if ($ascii > 127) {
						$car= '('.$ascii.')';
					}
					break;
			}
			echo "$car";
			$i++;
		}
	}
}

?>
